package hr.fer.oprpp1.hw04.db;

import java.util.ArrayList;
import java.util.List;

/**
 * Class which we use to parse the tokens generated by lexer to construct a query
 * @author Marko
 *
 */
public class QueryParser {
	List<Token> tokens;
	
	
	/**
	 * String query which we want to parse
	 * @param text
	 */
	public QueryParser(String text) {
		QueryLexer lex = new QueryLexer(text);
		tokens = new ArrayList<>();
		
		//get all the tokens
		lex.nextToken();
		while(lex.getToken().getType() != Type.EOF) {
			tokens.add(lex.getToken());
			lex.nextToken();
		}
	}
	
	/**
	 * Checks if the query input is of type "query jmbag="[JMBAG]""
	 */
	boolean isDirectQuery() {
		if(tokens.size() != 3) {
			return false;
		}
		
		Token idn = new Token(Type.IDN, "jmbag");
		Token equals = new Token(Type.OP, "=");
		Token string = new Token(Type.STRING, "");
		
		if(!idn.equals(tokens.get(0)) || !equals.equals(tokens.get(1)) || string.getType() != tokens.get(2).getType()) {
			return false;
		}
	
		return true;
	}
	
	/**
	 * Return the jmbag we want in O(1) time if it exists
	 * @return
	 */
	String getQueriedJMBAG() {
		if(!isDirectQuery()) {
			throw new IllegalArgumentException("This query is not direct");
		}
		return tokens.get(2).getText();
	}
	
	/**
	 * Returns the list of conditions that were generated by the query parser from the text we got in constructor
	 * @return
	 */
	List<ConditionalExpression> getQuery(){
		int currentIndex = 0;
		List<ConditionalExpression> exprs= new ArrayList<>();
	
		while(currentIndex < tokens.size() - 2) {
			
			if(tokens.get(currentIndex).getType() == Type.IDN && 
					tokens.get(currentIndex + 1).getType() == Type.OP && 
					tokens.get(currentIndex + 2).getType() == Type.STRING) {
				
				String getterType = tokens.get(currentIndex).getText();
				IFieldValueGetter getter = getGetterType(getterType);
				
				String operatorType = tokens.get(currentIndex + 1).getText();
				IComparisonOperator op = getOperatorType(operatorType);
				
				String string = tokens.get(currentIndex + 2).getText();
				ConditionalExpression expr = new ConditionalExpression(
						getter,
						string,
						op);
				
				exprs.add(expr);
			} else {
				throw new IllegalArgumentException("Error while parsing: pattern of query doesn't match \"IDN OP STRING\"");
			}
			
			try {
				if(tokens.get(currentIndex + 3).getType() == Type.OP && tokens.get(currentIndex + 3).getText().equals("and")) {
					currentIndex = currentIndex + 4;
					continue;
				} else {
					throw new IllegalArgumentException("Error while parsing: query subcomponents must be connected with AND");
				}
			} catch(IndexOutOfBoundsException e) {
				break;
			}	
		}
		
		return exprs;
	}

	/**
	 * Gets the variable type we want to get from the student record and then compare it by
	 */
	private IFieldValueGetter getGetterType(String getterType) {
		IFieldValueGetter getter = null;
		switch(getterType) {
		case "firstName":
			getter = FieldValueGetters.FIRST_NAME;
			break;
		case "lastName":
			getter = FieldValueGetters.LAST_NAME;
			break;
		case "jmbag": 
			getter = FieldValueGetters.JMBAG;
			break;
		}
		return getter;
	}
	
	/**
	 * Gets the operator type which we will use to compare the string and the student record variable
	 */
	private IComparisonOperator getOperatorType(String operatorType) {
		IComparisonOperator op = null;
		switch(operatorType) {
		case "=":
			op = ComparisonOperators.EQUALS;
			break;
		case ">":
			op = ComparisonOperators.GREATER;
			break;
		case "<":
			op = ComparisonOperators.LESS;
			break;
		case ">=":
			op = ComparisonOperators.GREATER_OR_EQUALS;
			break;
		case "<=":
			op = ComparisonOperators.LESS_OR_EQUALS;
			break;
		case "like":
			op = ComparisonOperators.LIKE;
			break;
		}
		return op;
	}
}
